#!/usr/bin/python -u
# -*- coding: UTF-8 -*-

from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.MenuList import MenuList
from Components.Label import Label
from Components.ActionMap import ActionMap
from twisted.web.client import getPage, downloadPage
from StringIO import StringIO
import re, os, zipfile, datetime, time

version = '15.10.04'
e2url = 'http://areq.eu.org/e2/'

def myreloadBouquets(self):
    try:
        from enigma import eDVBDB, eServiceReference, eServiceCenter
        print "[Listy] reloading lamedb"
        db = eDVBDB.getInstance()
        SatPositions=[50,70,90,100,130,160,192,215,235,255,260,284,305,313,330,360,390,400,420,450,490,530,550,570,600,620,642,685,705,720,750,800,852]
        for sat in SatPositions:
            db.removeServices(-1, -1, -1, sat)
        # ... teraz dodac to co potrzebujemy :)
        db.loadServicelist('/tmp/lamedb.aq')
        db.saveServicelist()
        db.removeServices()
        db.reloadServicelist()
        db.reloadBouquets()

        from Screens.InfoBar import InfoBar
        if InfoBar.instance is not None:
            #InfoBar.instance.servicelist.clearPath()
            #servicelist = InfoBar.instance.servicelist
            #service = self.session.nav.getCurrentlyPlayingServiceReference()
            #InfoBar.instance.servicelist.enterPath(service)
            #InfoBar.instance.servicelist.setCurrentSelection(service)
            #InfoBar.instance.servicelist.zap()

            servicelist = InfoBar.instance.servicelist
            #root = servicelist.getRoot()
            #currentref = servicelist.getCurrentSelection()
            servicelist.setRoot(servicelist.bouquet_root)
            #servicelist.setCurrentSelection(currentref)
            bouquet = servicelist.bouquet_root
            serviceHandler = eServiceCenter.getInstance()
            bouquetlist = serviceHandler.list(bouquet)
            servicelist.setRoot(bouquetlist.getNext())
    except:
        print "Richter - error in myreloadBouquets"
        import traceback
        traceback.print_exc()

class AQTools(Screen):

    skin = """
        <screen position="center,center" size="1200,595" title="AQTools by areq" flags="wfNoBorder">
            <eLabel text="http://areq.eu.org/ " position="3,2" size="600,32" zPosition="2" font="Regular;27" halign="left" backgroundColor="#193e" />
            <widget name="label_ver" position="600,2" size="600,32" font="Regular;27" halign="right" zPosition="3" backgroundColor="#193e" />
            <widget name="sats0" position="10,40" size="240,30" font="Regular;27" halign="left" backgroundColor="background"/>
            <widget name="sats" position="260,40" size="390,30" font="Regular;27" halign="left" backgroundColor="background" />
            <widget name="lista_stb" position="600,40" size="600,30" font="Regular;27" halign="right" />
            <widget name="menu" position="10,80" size="1100,500" itemHeight="34" font="Regular;26" scrollbarMode="showOnDemand" />
            </screen>"""

    def __init__(self, session, args = None):
        Screen.__init__(self, session)
        self.session = session
        self.richter_new = 'unknown'
        self.gzok = 0
        self.url = ''

        self["sats0"] = Label("Wykryte satelity:")

        satt = set()
        from Components.NimManager import nimmanager
        for nim in  nimmanager.getNimListOfType("DVB-S"):
            for s in nimmanager.getSatListForNim(nim):
                satt.add(s[0])
        print satt
        s = satsname(satt)
        self["sats"] = Label(s)

        try:
            t = os.path.getmtime('/etc/enigma2/lamedb')
            lamedb_date = str(datetime.datetime.fromtimestamp(t))[0:10]
        except:
            lamedb_date = 'nieznany'
        self["lista_stb"] = Label('Data obecnej listy: ' + lamedb_date)

        self.list = [( "Pobieram listę..", "")]
        self["menu"] = MenuList(self.list)
        #getPage('http://e2.areq.eu.org/richter/version').addCallback(self.updateCB).addErrback(self.errorUpdate)
        self.get_e2url()

        self["label_ver"] = Label("AQTools %s " % version)
        self["actions"] = ActionMap(["OkCancelActions"], {"cancel": self.close , "ok": self.ok}, -1)

    def get_e2url(self):
        getPage(e2url).addCallback(self.getlistsCB).addErrback(self.errorUpdate)

    def ok(self, val = False):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
            print "wybrano: =%s=" % returnValue
            if returnValue.startswith('http://'):
                    self.zipfile = returnValue.split('/')[-1]
                    getPage(returnValue).addCallback(self.getzipCB).addErrback(self.errorUpdate)
            elif returnValue == 'back':
                self.get_e2url()
            elif returnValue == 'exit':
                self.close()
            elif returnValue.startswith('inst:'):
                print "będzimy instalować: =%s=" % returnValue[5:]
                unpack(self.zip, returnValue[5:])
                myreloadBouquets(self)
                i = [('Nowa lista zainstalowana ;-)',''), ('Exit','exit')]
                self['menu'].setList(i)

    def getzipCB(self, html):
        try:
            print "\n\ngetzipCB-----------------------\n"
            self.zip = html
            i = [("Zawartość: %s. Potwierdz OK na liście" % self.zipfile, '')]
            z, d = zparse(html)
            m = 1
            for r in z.keys():
                m = max(m,len(r))
            for r in z.keys():
                sn = satsname(z[r])
                rn = (r + " "*m)[0:m + 4]
                i.append( ("  Instaluj: %i-%02i-%02i " % d[r][0:3] + rn + sn, 'inst:'+ r ) )

            i.append(('Wróć','back'))
            i.append(('Exit','exit'))
            print i

            if len(i)> 2:
                self['menu'].setList(i)
        except:
            print "getzipCB: error"
            import traceback
            traceback.print_exc()

    def getlistsCB(self, html):
        linkregex = re.compile('<a\s*href="(.*?\.zip)"..*?(202.-..-.. ..:..) ')
        i = []
        for l in linkregex.findall(html):
            if len(l)== 2:
                i.append((l[1][0:10] + ' ' +l[0], e2url + l[0] ))
        if len(i)> 1:
            i.append(('Exit','exit'))
            self['menu'].setList(i)


#       try:
#           new = dict([ l.split(':',1) for l in html.split("\n") if l.find(":") > 0])
#           if new.has_key('version'):
#               self["richter_new"].setText(new['version'])
#               self.richter_new = new['version']
#               self.url = new['url']
#               print "\n[Richter]", new['url']
#               if self.richter_new != self.richter_stb:
#                   self.gzok = 1
#                   downloadPage(self.url, '/tmp/richter.tgz').addCallback(self.richterCBgz).addErrback(self.errorUpdate)
#
#       except:
#           pass

    def richterCBgz(self, html):
        self.gzok = 2
        self["status"].setText('ZIELONY - zainstaluj pobrana liste')

    def updateCB(self, html):
        try:
            v = html.split('\n')[0]
            if v != version:
                self.session.openWithCallback(self.upgradeCB, MessageBox, "Dostepna jest nowa wersja pluginu Richter\n %s \n Instalowac ?" % v, MessageBox.TYPE_YESNO)
        except:
            pass

    def errorUpdate(self, html):
        print "\n[Richter] upgrade problem:", html

    def upgradeCB(self, result = None):
        print "\n[Richter] upgrade:", result
        if result:
            print "\n[Richter] upgrade yes\n"
            downloadPage('http://e2.areq.eu.org/richter/update.py','/usr/lib/enigma2/python/Plugins/Extensions/Richter/update.py').addCallback(self.goupCB).addErrback(self.errorUpdate)
        else:
            print "\n[Richter] upgrade cancel\n"

    def goupCB(self, html):
        print "\n[Richter] upgrade.py done:", html
        try:
            import update
            reload(update)
            self.session.open(update.DoUpdate)
        except:
            print "\n[Richter] upgrade.py - exception"
            import traceback
            traceback.print_exc()

def unpack(z, d):
        if len(d) > 1:
                d += '/'
        z = zipfile.ZipFile(StringIO( z ))
        FL = ['satellites.xml', 'bouquets.tv', 'bouquets.radio', 'lamedb']
        for x in ['bouquets.tv', 'bouquets.radio']:
                for l in z.read(d + x).replace("\r","").split('\n'):
                        if l.startswith('#SERVI'):
                                if l.find('"') > 1:
                                    FL.append(l.split('"')[1])
                                else:
                                    FL.append(l.split(':')[-1])
        for x in FL:
                try:
                        q = z.read(d + x)
                        t = time.mktime(z.getinfo(d + x).date_time + (0,0,0) )
                        f = '/etc/enigma2/' + x
                        if f.endswith('lamedb'):
                            f = '/tmp/lamedb.aq'
                        open(f, 'w').write(q)
                        os.utime(f, (t,t))
                except:
                        import traceback
                        traceback.print_exc()

def zparse(z):
    try:
        L={}
        D={}
        z = zipfile.ZipFile(StringIO( z ))
        for p in z.infolist():
                if p.file_size > 900000:
                        return []
                if p.filename.endswith('lamedb') and p.file_size > 1000:
                        s = {}
                        d = os.path.dirname(p.filename)
                        for l in z.read(p.filename).replace("\r","").split('\n'):
                                if l.startswith('\ts '):
                                        st = l.split(':')[4]
                                        if s.has_key(st):
                                                s[st]+=1
                                        else:
                                                s[st] = 1
                        L[d] = []
                        D[d] = p.date_time
                        for st in s:
                            if s[st] > 10:
                                L[d].append(int(st))
    except:
        print "[zparse] error"

    return L, D

def satsname(satt):
    satt = set(satt)
    print satt
    s = ''
    if 130 in satt:
        s+= "Hotbird"
    if 192 in satt:
        s+= " & Astra"
    if len(satt) > 2:
        s+= " & More"
    print s
    return s
